diff --git a/fw/http_sess.c b/fw/http_sess.c
index 18a170256..88b7ff33d 100644
--- a/fw/http_sess.c
+++ b/fw/http_sess.c
@@ -113,16 +113,6 @@ typedef struct {
 static const DEFINE_TFW_STR(redir_mark_eq, "__tfw=");
 static bool redir_mark_enabled, redir_mark_enabled_reconfig;
 
-void tfw_http_sess_redir_mark_enable(void)
-{
-	redir_mark_enabled = true;
-}
-
-void tfw_http_sess_redir_mark_disable(void)
-{
-	redir_mark_enabled = false;
-}
-
 void tfw_http_sess_redir_enable(void)
 {
 	redir_mark_enabled_reconfig = true;
diff --git a/fw/http_sess.h b/fw/http_sess.h
index cc47b53f5..92db31204 100644
--- a/fw/http_sess.h
+++ b/fw/http_sess.h
@@ -180,8 +180,6 @@ int tfw_http_sess_resp_process(TfwHttpResp *resp, bool cache);
 void tfw_http_sess_put(TfwHttpSess *sess);
 void tfw_http_sess_pin_vhost(TfwHttpSess *sess, TfwVhost *vhost);
 
-void tfw_http_sess_redir_mark_enable(void);
-void tfw_http_sess_redir_mark_disable(void);
 void tfw_http_sess_redir_enable(void);
 bool tfw_http_sess_max_misses(void);
 unsigned int tfw_http_sess_mark_size(void);
diff --git a/fw/t/unit/test_http1_parser.c b/fw/t/unit/test_http1_parser.c
index 140005b73..eb5ffdb56 100644
--- a/fw/t/unit/test_http1_parser.c
+++ b/fw/t/unit/test_http1_parser.c
@@ -3979,12 +3979,10 @@ TEST_SUITE(http1_parser)
 	 * Testing for correctness of redirection mark parsing (in
 	 * extended enforced mode of 'http_sessions' module).
 	 */
-	tfw_http_sess_redir_mark_enable();
-
+	TFW_HTTP_SESS_REDIR_MARK_ENABLE();
 	TEST_RUN(http1_parser, parses_enforce_ext_req);
 	TEST_RUN(http1_parser, parses_enforce_ext_req_rmark);
-
-	tfw_http_sess_redir_mark_disable();
+	TFW_HTTP_SESS_REDIR_MARK_DISABLE();
 
 	TEST_RUN(http1_parser, perf);
 }
diff --git a/fw/t/unit/test_http2_parser.c b/fw/t/unit/test_http2_parser.c
index 4c292b61a..2c8389f7f 100644
--- a/fw/t/unit/test_http2_parser.c
+++ b/fw/t/unit/test_http2_parser.c
@@ -2670,16 +2670,15 @@ TEST_SUITE(http2_parser)
 	TEST_RUN(http2_parser, date);
 	TEST_RUN(http2_parser, method_override);
 	TEST_RUN(http2_parser, vchar);
-	TEST_RUN(http2_parser, perf);
 
 	/*
 	 * Testing for correctness of redirection mark parsing (in
 	 * extended enforced mode of 'http_sessions' module).
 	 */
-	tfw_http_sess_redir_mark_enable();
-
+	TFW_HTTP_SESS_REDIR_MARK_ENABLE();
 	TEST_RUN(http2_parser, parses_enforce_ext_req);
 	TEST_RUN(http2_parser, parses_enforce_ext_req_rmark);
+	TFW_HTTP_SESS_REDIR_MARK_DISABLE();
 
-	tfw_http_sess_redir_mark_disable();
+	TEST_RUN(http2_parser, perf);
 }
diff --git a/fw/t/unit/test_http_parser_common.h b/fw/t/unit/test_http_parser_common.h
index 147972976..1ef30de31 100644
--- a/fw/t/unit/test_http_parser_common.h
+++ b/fw/t/unit/test_http_parser_common.h
@@ -43,12 +43,11 @@
 #endif
 #define EXPORT_SYMBOL(...)
 
-#include "http_parser.h"
-#include "http_sess.h"
-#include "str.h"
-#include "ss_skb.h"
 #include "msg.h"
+#include "str.h"
 #include "http_msg.h"
+#include "http_parser.h"
+#include "http_sess.h"
 
 static const unsigned int CHUNK_SIZES[] = { 1, 2, 3, 4, 8, 16, 32, 64, 128,
                                    256, 1500, 9216, 1024*1024
@@ -689,4 +688,27 @@ TfwStr get_next_str_val(TfwStr *str)
 	return v;
 }
 
+#define TFW_HTTP_SESS_REDIR_MARK_ENABLE()					\
+do {										\
+	extern int tfw_http_sess_init(void);					\
+	TfwMod *hs_mod = NULL;							\
+	int r = tfw_http_sess_init();						\
+	BUG_ON(r);								\
+	hs_mod = tfw_mod_find("http_sess");					\
+	BUG_ON(!hs_mod);							\
+	tfw_http_sess_redir_enable();						\
+	hs_mod->start();							\
+} while (0)
+
+#define TFW_HTTP_SESS_REDIR_MARK_DISABLE()					\
+do {										\
+	extern int tfw_http_sess_exit(void);					\
+	TfwMod *hs_mod = NULL;							\
+	hs_mod = tfw_mod_find("http_sess");					\
+	BUG_ON(!hs_mod);							\
+	hs_mod->stop();								\
+	hs_mod->cfgstart();							\
+	tfw_http_sess_exit();							\
+} while (0)
+
 #endif /* __TFW_HTTP_PARSER_COMMON_H__ */
